Function.RegisterNamespace("System.IO.DirectoryStrategy");

System.IO.DirectoryStrategy.Phantom=function(){
    var fs=null;

    // IDirectoryStrategy Members
    this.Exists=function(path){
        if(!!path){
            return fs.exists(path)&&fs.isDirectory(path);
        }
        return false;
    };

    this.GetFiles=function(path){
        var files=[];
        if(this.Exists(path)){
            var fileList=fs.list(path);
            for(var i=0;i<fileList.length;i++){
                if(fileList[i]=="."||fileList[i]=="..")continue;
                var absolutePath=System.IO.Path.Combine(path,fileList[i]);
                if(fs.isFile(absolutePath)){
                    files.push(absolutePath);
                }
            }
        }
        return files;
    };
    
    this.GetDirectories=function(path){
        var directories=[];
        if(this.Exists(path)){
            var directoryList=fs.list(path);
            for(var i=0;i<directoryList.length;i++){
                if(directoryList[i]=="."||directoryList[i]=="..")continue;
                var absolutePath=System.IO.Path.Combine(path,directoryList[i]);
                if(fs.isDirectory(absolutePath)){
                    directories.push(absolutePath);
                }
            }
        }
        return directories;
    };

    // IStrategySpecification Members
    this.IsSatisfiedBy=function(candidate){
        if(typeof(phantom)!="undefined"&&typeof(require)=="function"){
            fs=require("fs");
            return true;
        }
        return false;
    };

};

System.IO.DirectoryStrategy.Phantom.Implement(System.IO.DirectoryStrategy.IDirectoryStrategy,'System.IO.DirectoryStrategy.Phantom');
System.IO.DirectoryStrategy.Phantom.Implement(System.Script.Strategy.IStrategySpecification,'System.IO.DirectoryStrategy.Phantom');

System.IO.Directory.Strategies.Add(System.IO.DirectoryStrategy.Phantom,0);